macro
: drop $068b 2, $04c683 3, ;

self
: ( ') parse drop drop ; ( no comments before this!! )
: | 10 parse drop drop ; | no comments before this!!

| QuickForth 2005 based on RetroForth 8.2.5
| (c) Golik D. N. 2005
| Retroforth (c) retroforth.org

forth
: wsparse 32 parse ;
: lnparse 10 parse ;
: ' wsparse find ;
: m' wsparse mfind ;
: f' wsparse ffind ;

macro
: x:  ' compile ;
: ['] ' x: literal ;
: c: x: ['] ['] compile compile ;
: m: m' compile ; | this is needed for dwords.f!!
: f: f' compile ;

uses" dwords.f" | primitive data manipulation functions

| language processing words

forth
: here h0 @ ;
: getstackpointer dup [ $f089 2, ] ; | mov eax, esi
: setstackpointer [ $c689 2, ] ; | mov esi, eax

: class'  wsparse rot classfind ;
: reclass last @ 8 + ! ;
: reclass: class @ ' drop which @ 8 + ! ;

macro
| : call $d0ff 2, $068b 2, $04c683 3, ; | call eax; drop
: class: class' compile ;
: as ' x: literal c: reclass ;

: (if) $063b 2, $adad 2, 1, here 0 1, ; |   if | cmp eax, [esi]; lodsd; lodsd
: (0if) $c009 2, $ad 1, 1, here 0 1, ; |   0if or eax, eax; lodsd
: <>if $74 x: (if) ; | je
: =if  $75 x: (if) ; | jne
: >if  $7d x: (if) ; | jge
: <if  $7e x: (if) ; | jle
: >=if $7f x: (if) ; | jg
: <=if $7c x: (if) ; | jl
: ?if  $72 1, here 0 1, ; | jc
: if $74 m: (0if) ; | or eax, eax; je [then]
: 0if $75 m: (0if) ; | or eax, eax; jne [then]
: then dup here swap - 1- swap c!  $90 1, here 1- h0 ! ; |    nop??    tail call!!
: else $eb 1, here 0 1, swap m: then ; | jmp byte [then]
: ;then x: ;; x: then ;

: for here m: >r ;
: next m: r> m: 1- $8f0f 2, here - 4 - , m: drop ;

: repeat here ;
: again compile x: ;; ;
: until m: 0if swap m: again m: then ;

: while m: repeat m: if ;
: do swap m: again m: then ;

forth
: later r> r> swap >r >r ;
: execute >r ;

: cmp2bool m: true m: else m: false m: then ;

: fast last @ dup 13 + dup 1- c@ entry as .forth 4 + @ execute x: ;; ; | makes forth word by executing last word, like : dup dup ;

macro
: =   m: =if  cmp2bool ;
: <>  m: <>if cmp2bool ;
: >   m: >if  cmp2bool ;
: <   m: <if  cmp2bool ;
: >=  m: >=if cmp2bool ;
: <=  m: <=if cmp2bool ;
: =0  m: 0if  cmp2bool ;
: <>0 m: if  cmp2bool ;
: >0  $7e m: (0if) cmp2bool ; | jle
: <0  $7d m: (0if) cmp2bool ; | jge
: >=0 $7c m: (0if) cmp2bool ; | jl
: <=0 $7f m: (0if) cmp2bool ; | jg

forth
: =   = ;
: <>  <> ;
: >   > ;
: <   < ;
: >=  >= ;
: <=  <= ;
: =0  =0 ;
: <>0 <>0 ;
: >0  >0 ;
: <0  <0 ;
: >=0 >=0 ;
: <=0 <=0 ;

macro
: prior last @ >r last @ @ last ! wsparse find compile r> last ! ;
: vector $90909090 , $90 1, ;
: class> here 14 + x: literal c: reclass x: ;; ;

forth
: 0; dup 0if rdrop drop then ;

: create: wsparse entry ;
: literal, x: literal ;

: create create: as .data ;
: var 0 : var: create , ;
: const create last @ cell+ ! ;
: define here const ; | like in c++!!
: stringdefined find ?if drop true else 2drop false then ;
: defined wsparse stringdefined ;

: +! dup @ rot + swap ! ;
: -! dup @ rot - swap ! ;
: allot h0 +! ;
: array create allot ;
: pointer 2 array ;

forth
: :: here ] ;
: alias create: last @ cell+ ! ;
 
: is here swap ' h0 ! compile x: ;; h0 ! ;
: devector $90909090 ' $90 over c! 1+ ! ;
 
create list 8 cells allot
: loc: 1 list +! list @ cells list + last @ swap ! ;
: ;loc list @ cells list + @ last ! 1 list -! ;

| strings and i/o

forth
: move [ $57 1, $56 1, $c189 2, $02e9c1 3, $3e8b 2, $04768b 3, $a5f3 2,
       $c189 2, $03e183 3, $a4f3 2, $5e 1, $5f 1, $08468b 3, $0cc683 3, ] ;
| push edi; push esi; mov ecx, eax; shr ecx, 2; mov edi, [esi]; mov esi, [esi+4]; rep movsd
| mov ecx, eax; and ecx, 3; rep movsb; pop esi; pop edi; mov eax, [esi+8]; add esi, 12
: fill [ $57 1, $c289 2, $08e2c1 3, $d009 2, $08e2c1 3, $d009 2, $08e2c1 3, $d009 2,  $0e8b 2, $047e8b 3,
       $ca89 2, $02e9c1 3, $abf3 2, $03e283 3, $d189 2, $aaf3 2, $5f 1, $08468b 3, $0cc683 3, ] ;
| push edi; mov edx, eax; shl edx, 8; or eax, edx; shl edx, 8; or eax, edx; shl edx, 8; or eax, edx; mov ecx, [esi];
| mov edi, [esi+4]; mov edx, ecx; shr ecx, 2; rep stosd; and edx, 3; mov ecx, edx; rep stosb; pop edi; mov eax, [esi+8]; add esi, 12;
: place dup >r swap move r> ;
: pad here 1024 + ;
: >pad dup 0; >r pad place r> ;

: " '" parse >pad ;

loc:
  : .string dup r> + dup >r over - swap ;
 :: dup literal, dup >r here 5 + place drop c: .string r> allot ;
;loc alias $,

macro
: s" " $, ;
: { '} parse $, c: eval ;

self
: ." state @ if " $, c: type ;then " type ;

forth
: space vector 32 emit ;
: cr vector 10 emit ;
: . vector dup 0 <if '- emit negate then : u. vector # space ;
 
loc:
  var size
  : make dup -rot here place swap dup allot 0 1, 1+ size +! ;
  : free size @ negate allot 0 size ! ;
  :: make later free ;
;loc alias zt

loc:
  : list 0 last repeat @ 0; dup 13 + dup 1- c@ type space swap 1+ swap again ;
 :: list cr . ." words defined" cr ;
;loc alias words

: hex 16 base ! ;
: decimal 10 base ! ;
: binary 2 base ! ;
: octal 8 base ! ;

: .s 10 for r@ 1- [ $86048b 3, ] . next cr ;

uses" windows.f" | windows-dependent functions

| uses" float10.f" | floating point with 10-byte precision
uses" float8.f" | floating point with 8-byte precision
| uses" float4.f" | floating point with 4-byte precision

| uses" math.f"

| reset

." QuickForth build 01.2006 successfully loaded!!" cr cr
